using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using NUnit.Framework;
using OpenQA.Selenium;
using OpenQA.Selenium.Firefox;
using OpenQA.Selenium.Support.UI;

namespace SeleniumTests
{
    [TestFixture]
    public class WyszukiwanieWikipedia
    {
        private IWebDriver driver;
        private StringBuilder verificationErrors;
        private string baseURL;
        private bool acceptNextAlert = true;
        WebDriverWait wait;
        
        [SetUp]
        public void SetupTest()
        {
            driver = new FirefoxDriver();
            baseURL = "https://www.google.pl/";
            verificationErrors = new StringBuilder();
            //driver.Manage().Timeouts().ImplicitlyWait(TimeSpan.FromSeconds(30));
        }
        
        [TearDown]
        public void TeardownTest()
        {
            try
            {
                driver.Quit();
            }
            catch (Exception)
            {
                // Ignore errors if unable to close the browser
            }
            Assert.AreEqual("", verificationErrors.ToString());
        }
        
        [Test]
        public void TheWyszukiwanieWikipediaTest()
        {
            driver.Navigate().GoToUrl(baseURL + "/?gws_rd=ssl");
            driver.FindElement(By.Id("lst-ib")).Clear();
            driver.FindElement(By.Id("lst-ib")).SendKeys("wikipedia");
            driver.FindElement(By.Name("btnG")).Click();
            PoczekajNaZaladowanieElementu(By.LinkText("Wikipedia, wolna encyklopedia")).Click();
            try
            {
            	SprawdzTytulNaStronie("dfklgj490");
            	Assert.AreEqual("Historia i autorzy", PoczekajNaZaladowanieElementu(By.LinkText("Historia i autorzy")).Text);
            }
            catch (AssertionException e)
            {
                verificationErrors.Append(e.Message);
            }
            try
            {
                Assert.AreEqual("Tekst źródłowy", driver.FindElement(By.LinkText("Tekst źródłowy")).Text);
            }
            catch (AssertionException e)
            {
                verificationErrors.Append(e.Message);
            }
            try
            {
                Assert.AreEqual("Czytaj", driver.FindElement(By.LinkText("Czytaj")).Text);
            }
            catch (AssertionException e)
            {
                verificationErrors.Append(e.Message);
            }
        }
        
        public IWebElement PoczekajNaZaladowanieElementu(By by, int sekundy = 10)
        {
        	wait = new WebDriverWait(driver, TimeSpan.FromSeconds(sekundy));
            IWebElement element = wait.Until(x=> driver.FindElement(by));
            
            return element;
        }
        
        public IWebElement SprawdzCzyElementJestWidoczny(By by, int sekundy = 10)
        {
        	wait = new WebDriverWait(driver, TimeSpan.FromSeconds(sekundy));
            IWebElement element = wait.Until(ExpectedConditions.ElementIsVisible(by));
            
            return element;
        }
        
        public void SprawdzTytulNaStronie(string tytul, int sekundy = 10)
        {
        	wait = new WebDriverWait(driver, TimeSpan.FromSeconds(sekundy));
        	wait.Until(ExpectedConditions.TitleContains(tytul));
            
        }
        private bool IsElementPresent(By by)
        {
            try
            {
                driver.FindElement(by);
                return true;
            }
            catch (NoSuchElementException)
            {
                return false;
            }
        }
        
        private bool IsAlertPresent()
        {
            try
            {
                driver.SwitchTo().Alert();
                return true;
            }
            catch (NoAlertPresentException)
            {
                return false;
            }
        }
        
        private string CloseAlertAndGetItsText() {
            try {
                IAlert alert = driver.SwitchTo().Alert();
                string alertText = alert.Text;
                if (acceptNextAlert) {
                    alert.Accept();
                } else {
                    alert.Dismiss();
                }
                return alertText;
            } finally {
                acceptNextAlert = true;
            }
        }
    }
}
